// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package convo

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion7

// ConvoClient is the client API for Convo service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ConvoClient interface {
	ClientHandshake(ctx context.Context, in *ClientHandshakeRequest, opts ...grpc.CallOption) (*ClientHandshakeReply, error)
	ClientAuthenticate(ctx context.Context, in *ClientAuthenticateRequest, opts ...grpc.CallOption) (*ClientAuthenticateReply, error)
	ListRooms(ctx context.Context, in *ListRoomsRequest, opts ...grpc.CallOption) (*ListRoomsReply, error)
	RoomKey(ctx context.Context, in *RoomKeyRequest, opts ...grpc.CallOption) (*RoomKeyReply, error)
	RoomAction(ctx context.Context, opts ...grpc.CallOption) (Convo_RoomActionClient, error)
}

type convoClient struct {
	cc grpc.ClientConnInterface
}

func NewConvoClient(cc grpc.ClientConnInterface) ConvoClient {
	return &convoClient{cc}
}

func (c *convoClient) ClientHandshake(ctx context.Context, in *ClientHandshakeRequest, opts ...grpc.CallOption) (*ClientHandshakeReply, error) {
	out := new(ClientHandshakeReply)
	err := c.cc.Invoke(ctx, "/convo.Convo/ClientHandshake", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *convoClient) ClientAuthenticate(ctx context.Context, in *ClientAuthenticateRequest, opts ...grpc.CallOption) (*ClientAuthenticateReply, error) {
	out := new(ClientAuthenticateReply)
	err := c.cc.Invoke(ctx, "/convo.Convo/ClientAuthenticate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *convoClient) ListRooms(ctx context.Context, in *ListRoomsRequest, opts ...grpc.CallOption) (*ListRoomsReply, error) {
	out := new(ListRoomsReply)
	err := c.cc.Invoke(ctx, "/convo.Convo/ListRooms", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *convoClient) RoomKey(ctx context.Context, in *RoomKeyRequest, opts ...grpc.CallOption) (*RoomKeyReply, error) {
	out := new(RoomKeyReply)
	err := c.cc.Invoke(ctx, "/convo.Convo/RoomKey", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *convoClient) RoomAction(ctx context.Context, opts ...grpc.CallOption) (Convo_RoomActionClient, error) {
	stream, err := c.cc.NewStream(ctx, &_Convo_serviceDesc.Streams[0], "/convo.Convo/RoomAction", opts...)
	if err != nil {
		return nil, err
	}
	x := &convoRoomActionClient{stream}
	return x, nil
}

type Convo_RoomActionClient interface {
	Send(*UserAction) error
	Recv() (*UserAction, error)
	grpc.ClientStream
}

type convoRoomActionClient struct {
	grpc.ClientStream
}

func (x *convoRoomActionClient) Send(m *UserAction) error {
	return x.ClientStream.SendMsg(m)
}

func (x *convoRoomActionClient) Recv() (*UserAction, error) {
	m := new(UserAction)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// ConvoServer is the server API for Convo service.
// All implementations must embed UnimplementedConvoServer
// for forward compatibility
type ConvoServer interface {
	ClientHandshake(context.Context, *ClientHandshakeRequest) (*ClientHandshakeReply, error)
	ClientAuthenticate(context.Context, *ClientAuthenticateRequest) (*ClientAuthenticateReply, error)
	ListRooms(context.Context, *ListRoomsRequest) (*ListRoomsReply, error)
	RoomKey(context.Context, *RoomKeyRequest) (*RoomKeyReply, error)
	RoomAction(Convo_RoomActionServer) error
	mustEmbedUnimplementedConvoServer()
}

// UnimplementedConvoServer must be embedded to have forward compatible implementations.
type UnimplementedConvoServer struct {
}

func (UnimplementedConvoServer) ClientHandshake(context.Context, *ClientHandshakeRequest) (*ClientHandshakeReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ClientHandshake not implemented")
}
func (UnimplementedConvoServer) ClientAuthenticate(context.Context, *ClientAuthenticateRequest) (*ClientAuthenticateReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ClientAuthenticate not implemented")
}
func (UnimplementedConvoServer) ListRooms(context.Context, *ListRoomsRequest) (*ListRoomsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListRooms not implemented")
}
func (UnimplementedConvoServer) RoomKey(context.Context, *RoomKeyRequest) (*RoomKeyReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RoomKey not implemented")
}
func (UnimplementedConvoServer) RoomAction(Convo_RoomActionServer) error {
	return status.Errorf(codes.Unimplemented, "method RoomAction not implemented")
}
func (UnimplementedConvoServer) mustEmbedUnimplementedConvoServer() {}

// UnsafeConvoServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ConvoServer will
// result in compilation errors.
type UnsafeConvoServer interface {
	mustEmbedUnimplementedConvoServer()
}

func RegisterConvoServer(s grpc.ServiceRegistrar, srv ConvoServer) {
	s.RegisterService(&_Convo_serviceDesc, srv)
}

func _Convo_ClientHandshake_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ClientHandshakeRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConvoServer).ClientHandshake(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/convo.Convo/ClientHandshake",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConvoServer).ClientHandshake(ctx, req.(*ClientHandshakeRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Convo_ClientAuthenticate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ClientAuthenticateRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConvoServer).ClientAuthenticate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/convo.Convo/ClientAuthenticate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConvoServer).ClientAuthenticate(ctx, req.(*ClientAuthenticateRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Convo_ListRooms_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListRoomsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConvoServer).ListRooms(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/convo.Convo/ListRooms",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConvoServer).ListRooms(ctx, req.(*ListRoomsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Convo_RoomKey_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RoomKeyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ConvoServer).RoomKey(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/convo.Convo/RoomKey",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ConvoServer).RoomKey(ctx, req.(*RoomKeyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Convo_RoomAction_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(ConvoServer).RoomAction(&convoRoomActionServer{stream})
}

type Convo_RoomActionServer interface {
	Send(*UserAction) error
	Recv() (*UserAction, error)
	grpc.ServerStream
}

type convoRoomActionServer struct {
	grpc.ServerStream
}

func (x *convoRoomActionServer) Send(m *UserAction) error {
	return x.ServerStream.SendMsg(m)
}

func (x *convoRoomActionServer) Recv() (*UserAction, error) {
	m := new(UserAction)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

var _Convo_serviceDesc = grpc.ServiceDesc{
	ServiceName: "convo.Convo",
	HandlerType: (*ConvoServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ClientHandshake",
			Handler:    _Convo_ClientHandshake_Handler,
		},
		{
			MethodName: "ClientAuthenticate",
			Handler:    _Convo_ClientAuthenticate_Handler,
		},
		{
			MethodName: "ListRooms",
			Handler:    _Convo_ListRooms_Handler,
		},
		{
			MethodName: "RoomKey",
			Handler:    _Convo_RoomKey_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "RoomAction",
			Handler:       _Convo_RoomAction_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "chat.proto",
}
